com.ihr.xbrl.om.table.structural

## Class DimensionDefaultRule

- java.lang.Object
- - com.ihr.xbrl.om.table.structural.DimensionDefaultRule

- All Implemented Interfaces:
    DimensionAspectInterface<javax.xml.namespace.QName>, ExplicitDimensionAspectInterface, Aspect<DimensionAndValuePair<javax.xml.namespace.QName>>

      public class DimensionDefaultRule
      extends java.lang.Object
      implements ExplicitDimensionAspectInterface

  The Class DimensionDefaultRule.
  Author:
    Ignacio

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DimensionDefaultRule(javax.xml.namespace.QName dimension, javax.xml.namespace.QName _default)` Instantiates a new dimension default rule.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getAspectClashIdentity()` Returns an object that can be used to evaluate aspect clash.
    `int` | `getAspectType()` Returns a value from the CommonAspectRule class that identifies the aspect type.
    `javax.xml.namespace.QName` | `getDimension()` Gets the dimension.
    `javax.xml.namespace.QName` | `getMember(XBRLStructuralTable xbrlTable)` Obtains the member this aspect resolves to.
    `DimensionAndMemberQNamesPair` | `getMember(XBRLStructuralTable table, CellHeader[] header)` Convert this aspect into a proper Member
    `int` | `getMembersCount()` Gets the members count.
    `void` | `resetNode()` Reset node.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DimensionDefaultRule

          public DimensionDefaultRule(javax.xml.namespace.QName dimension,
                              javax.xml.namespace.QName _default)

      Instantiates a new dimension default rule.
      Parameters:
        `dimension` - the dimension
        `_default` - the _default

  - ### Method Detail

    - #### getAspectClashIdentity

          public java.lang.Object getAspectClashIdentity()

      Description copied from interface: `Aspect`
      Returns an object that can be used to evaluate aspect clash.
      Specified by:
        `getAspectClashIdentity` in interface `Aspect<DimensionAndValuePair<javax.xml.namespace.QName>>`
      Returns:
        the aspect clash identity

    - #### getAspectType

          public int getAspectType()

      Description copied from interface: `Aspect`
      Returns a value from the CommonAspectRule class that identifies the aspect type.
      Specified by:
        `getAspectType` in interface `Aspect<DimensionAndValuePair<javax.xml.namespace.QName>>`
      Returns:
        the aspect type

    - #### getDimension

          public javax.xml.namespace.QName getDimension()

      Description copied from interface: `DimensionAspectInterface`
      Gets the dimension.
      Specified by:
        `getDimension` in interface `DimensionAspectInterface<javax.xml.namespace.QName>`
      Returns:
        the dimension

    - #### getMember

          public javax.xml.namespace.QName getMember(XBRLStructuralTable xbrlTable)

      Description copied from interface: `ExplicitDimensionAspectInterface`
      Obtains the member this aspect resolves to.
      Specified by:
        `getMember` in interface `ExplicitDimensionAspectInterface`
      Parameters:
        `xbrlTable` - the structural table that may contain parameters in case the the member has to be evaluated using an XPath expression
      Returns:
        QName, dimension member

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getMembersCount

          public int getMembersCount()

      Description copied from interface: `DimensionAspectInterface`
      Gets the members count.
      Specified by:
        `getMembersCount` in interface `DimensionAspectInterface<javax.xml.namespace.QName>`
      Returns:
        the members count

    - #### resetNode

          public void resetNode()

      Description copied from interface: `DimensionAspectInterface`
      Reset node.
      Specified by:
        `resetNode` in interface `DimensionAspectInterface<javax.xml.namespace.QName>`

    - #### getMember

          public DimensionAndMemberQNamesPair getMember(XBRLStructuralTable table,
                                               CellHeader[] header)

      Description copied from interface: `Aspect`
      Convert this aspect into a proper Member depending on the aspect type. Member can be used later to search for facts that satisfy the set of members
      Specified by:
        `getMember` in interface `Aspect<DimensionAndValuePair<javax.xml.namespace.QName>>`
      Parameters:
        `table` - the table
        `header` - the header
      Returns:
        the member